/*
 *	Copyright (c) 2024 Scott Duensing, scott@kangaroopunch.com
 *
 *	Permission is hereby granted, free of charge, to any person obtaining a copy
 *	of this software and associated documentation files (the "Software"), to deal
 *	in the Software without restriction, including without limitation the rights
 *	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *	copies of the Software, and to permit persons to whom the Software is
 *	furnished to do so, subject to the following conditions:
 *
 *	The above copyright notice and this permission notice shall be included in
 *	all copies or substantial portions of the Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *	SOFTWARE.
 */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "portme.h"
#include "story.h"
#include "state.h"
#include "interpreter.h"

#pragma push_macro("bool")
#undef bool
#include <curses.h>
#pragma pop_macro("bool")

#include "zork1.h"
//#include "czech.z3.h"


// The F256 has 512k of RAM.  We use everything except the lower 64k.
static uint8_t _RAM[1024 * (512 - 64)];


uint8_t portByteGet(uint32_t address) {
	return _RAM[address];
}


void portByteSet(uint32_t address, uint8_t value) {
	_RAM[address] = value;
}


char portCharGet(void) {
#if 1
	static char     playback[] = "open mailbox\ntake leaflet\nread leaflet\n";
	static uint32_t pointer = 0;

	if (pointer < strlen(playback)) return playback[pointer++];

	return getch();
#else
	return getch();
#endif
}


void portCharGetPos(byte *x, byte *y) {
	byte xt;
	byte yt;

	getyx(stdscr, yt, xt);

	*x = xt + 1;
	*y = yt + 1;
}


void portCharPrint(char c) {
	addch(c);
	refresh();
}


void portCharSetPos(byte x, byte y) {
	move(x - 1, y - 1);
}


void portDie(char *fmt, ...) {
	va_list ap;

	endwin();

	printf("\n");
	va_start(ap, fmt);
	vprintf(fmt, ap);
	va_end(ap);
	printf("\n");

	exit(1);
}


bool portFileRestore(void) {

	FILE *in;
	bool  ok  = false;

	in = fopen("save.dat", "rb");
	if (in) {
		ok = true;

		// Read in PC.
		ok &= (fread(&__state.pc, sizeof(__state.pc), 1, in) == 1);
		// Read in SP.
		ok &= (fread(&__state.sp, sizeof(__state.sp), 1, in) == 1);
		// Read in BP.
		ok &= (fread(&__state.bp, sizeof(__state.bp), 1, in) == 1);
		// Read in dynamic game RAM.
		ok &= (fread(_RAM, storyStaticMemoryBaseAddress(), 1, in) == 1);
		// Read in stack.
		ok &= (fread(__state.stack, sizeof(__state.stack[0]), __state.sp, in) == __state.sp);

		fclose(in);
	}

	return ok;
}


bool portFileSave(void) {
	FILE *out;
	bool  ok  = false;

	out = fopen("save.dat", "wb");
	if (out) {
		ok = true;

		// Write out PC.
		ok &= (fwrite(&__state.pc, sizeof(__state.pc), 1, out) == 1);
		// Write out SP.
		ok &= (fwrite(&__state.sp, sizeof(__state.sp), 1, out) == 1);
		// Write out BP.
		ok &= (fwrite(&__state.bp, sizeof(__state.bp), 1, out) == 1);
		// Write out dynamic game RAM.
		ok &= (fwrite(_RAM, storyStaticMemoryBaseAddress(), 1, out) == 1);
		// Write out stack.
		ok &= (fwrite(__state.stack, sizeof(__state.stack[0]), __state.sp, out) == __state.sp);

		fclose(out);
	}

	return ok;
}


uint16_t portRandomGet(int16_t range) {
	// If range is zero, randomize with "best" random seed.
	// If range is negative, use the positive value to seed.

	return 42;
}


void portStoryLoad(void) {
	// For now, we just copy an embedded Zork 1 into RAM.
	memcpy(_RAM, zork1, zork1_len);
	//memcpy(_RAM, czech_z3, czech_z3_len);
}


uint16_t portWordGet(uint32_t address) {
	return ((uint16_t)_RAM[address] << 8) | ((uint16_t)_RAM[address + 1]);
}


void portWordSet(uint32_t address, uint16_t value) {
	_RAM[address]     = (value >> 8) & 0xff;   // MSB first.
	_RAM[address + 1] = value & 0xff;
}


int main(void) {

	initscr();
	cbreak();
	noecho();

	stateReset();
	portStoryLoad();
	opcodesSetup();
	storySetup(COLS - 1, LINES - 1);
	interpreterRun();

	endwin();

	return 0;
}
